'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _camelCase = require('lodash/camelCase');

var _camelCase2 = _interopRequireDefault(_camelCase);

var _upperCase = require('lodash/upperCase');

var _upperCase2 = _interopRequireDefault(_upperCase);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Reduxable = function () {
  function Reduxable() {
    _classCallCheck(this, Reduxable);
  }

  Reduxable.setStore = function setStore(store) {
    this._store = store;
  };

  Reduxable.prototype.setScope = function setScope(scope) {
    this._scope = scope;
  };

  Reduxable.prototype.dispatch = function dispatch() {
    this.constructor._store.dispatch(arguments);
  };

  Reduxable.prototype.getState = function getState() {
    var state = this.constructor._store.getState();
    return this._scope.split('.').reduce(function (object, scopeKey) {
      return object[scopeKey];
    }, state);
  };

  Reduxable.prototype.getReducer = function getReducer() {
    var _this = this;

    return function () {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _this.state;
      var action = arguments[1];

      if (action.scope !== _this._scope) {
        return state;
      }

      var type = (0, _camelCase2['default'])(action.type);
      var method = _this.reducers[type];

      if (method) {
        return method(state, action);
      }

      return state;
    };
  };

  _createClass(Reduxable, [{
    key: 'actions',
    get: function get() {
      var _this2 = this;

      if (!this._actions) {
        this._actions = {};

        for (var reducer in this.reducers) {
          if (this.reducers.hasOwnProperty(reducer)) {
            (function () {
              var type = (0, _upperCase2['default'])(reducer).replace(' ', '_');
              var scope = _this2._scope;
              _this2._actions[reducer] = function (action) {
                return _extends({}, action, { type: type, scope: scope });
              };
            })();
          }
        }
      }

      return this._actions;
    }
  }, {
    key: 'dispatchers',
    get: function get() {
      var _this3 = this;

      if (!this._boundedActions) {
        this._boundedActions = {};

        for (var reducer in this.reducers) {
          if (this.reducers.hasOwnProperty(reducer)) {
            (function () {
              var type = (0, _upperCase2['default'])(reducer).replace(' ', '_');
              var dispatch = _this3.constructor._store.dispatch;
              var scope = _this3._scope;
              _this3._boundedActions[reducer] = function (action) {
                return dispatch(_extends({}, action, { type: type, scope: scope }));
              };
            })();
          }
        }
      }

      return this._boundedActions;
    }
  }]);

  return Reduxable;
}();

exports['default'] = Reduxable;